#ifndef _plugin_
#define _plugin_

#ifdef __cplusplus
extern "C" {
#endif
  
#define FP_READ 1
#define FP_WRITE 2

#define FP_NORMAL 0
#define FP_CANCEL 1
#define FP_LEVEL_ERROR 2
#define FP_OUT_OF_MEMORY 3
#define FP_OPEN_ERROR 4
#define FP_READ_ERROR 5
#define FP_WRITE_ERROR 6
#define FP_PARAM_ERROR 7
#define FP_OTHER_ERROR 100

  typedef struct _FilePlugInData1 {
    char* readExtensionList;
    char* writeExtension;
    char* version;
    char* description;
    char* copyright;
    char* comment;
    int suportedMode;
  } FilePlugInData1;
  
  typedef struct _FilePlugInParam1 {
    char* fileName;
    long width;
    long height;
    long resolution;
    char* bits;
  } FilePlugInParam1;
  
#ifdef __GNUC__
#ifdef _System
#else
#define _System
#endif
#endif

  long _System FpVersionCheck(long apLevel, long* suportLevel);
  long _System FpGetPlugInInfo(long level, void* data, long* need);
  long _System FpGetFileInfo(long level, void* param);
  long _System FpRead(long level, void* param);
  long _System FpWrite(long level, void* param);
  long _System FpOption(long level, HWND owner, PSZ mainPath);

#ifdef __cplusplus
}
#endif

#endif
